-- vipsecureCLI.lua
-- Samer Sayeed
-- TeamF1
-- www.TeamF1.com
--
-- Modification History
-- 10Oct13,ksr Dixed SPR 38898
-- 30sep13,nik Fixed SPR 39866
-- 22apr13,nik Fixed SPR 36646
-- 30mar13,nik Fixed SPR 36529
-- 19mar13,nik Fixed SPR #36625
-- 19mar13,nik Fixed SPR #36623
-- 06Dec12,ksr fixed SPR 35011
-- 04Jul12,sig Fixed SPR 33122
-- 10may12,nik fixed SPR 31510
-- 29nov11,nik changes to fix SPR 28138 and 28141
-- 24nov11,nik changes to fix SPR 28028
-- 08mar10,rac added/modifed the file to comply with the latest changes
-- 31jan09,ss  did modifications in ipsecVpnPolicyCfgInputVal() routine 
-- 29nov08,ss  written 
--
-- Description
-- CLI interface set and get routines
require "teamf1lualib/vipSecure"
--require "teamf1lualib/ipSec"
require "teamf1lualib/dhcpOverIpSec"
function ipsecVpnPolicyCfgInit(args)
        local configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])
        local configRowIke={}
        local configRowVpn={}
        if (configRow == nil)then --new  policy initialization
                --configRowVpn = db.getDefaults(true, "IpsecVPNPolicy")
                configRowVpn["IpsecVPNPolicy.VPNPolicyName"]=args[1]
                configRowVpn["IpsecVPNPolicy.PFSKeyGroup1"] = "2"
                configRowVpn["IpsecVPNPolicy.PFSKeyGroup"] = "0"
                configRowVpn["IpsecVPNPolicy.EnableKeepAlive"] = "0"
                configRowVpn["IpsecVPNPolicy.SALifeTimeType"] = "0"
                configRowVpn["IpsecVPNPolicy.AuthAlgorithm"] = "2"
                configRowVpn["IpsecVPNPolicy.LocalGateway"] = "0"
                configRowVpn["IpsecVPNPolicy.Netbios"] = "0"
                configRowVpn["IpsecVPNPolicy.SALifeTime"] = "3600"
                configRowVpn["IpsecVPNPolicy.EncryptionAlgorithm"] = "2"
                configRowVpn["IpsecVPNPolicy.AutoInitiate"] = "0"
                configRowVpn["IpsecVPNPolicy.PolicyType"] = "1"
                configRowVpn["IpsecVPNPolicy.RemoteEndPointType"] = "0"
                configRowVpn["IpsecVPNPolicy.AddressFamily"] = "2"
                configRowVpn["IpsecVPNPolicy.LocalNetworkType"] = "3"
                configRowVpn["IpsecVPNPolicy.RemoteNetworkType"] = "3"
                configRowVpn["IpsecVPNPolicy.Rollover"] = "0"
                RowId="-1"
        else  --existing policy initialization
                RowId=configRow["IpsecVPNPolicy._ROWID_"]
                local ikeName = db.getAttribute ("IpsecVPNPolicy","_ROWID_",RowId,"IKEPolicyName")
                configRowVpn = db.getRow("IpsecVPNPolicy", "_ROWID_", RowId)
                if (configRowVpn["IpsecVPNPolicy.PolicyType"] == "1") then --for auto policy concatinating ike and vpn
                    local ikeRowId = db.getAttribute ("IpsecIKEPolicy","IKEPolicyName",ikeName,"_ROWID_")
                    configRowIke = db.getRow("IpsecIKEPolicy", "_ROWID_", ikeRowId)
                    configRowVpn["IpsecVPNPolicy.ModeConfigStatus"] = configRowIke["IpsecIKEPolicy.ModeConfigStatus"]
                    configRowVpn["IpsecVPNPolicy.Direction"] = configRowIke["IpsecIKEPolicy.Direction"]
                end
                if (configRowVpn["IpsecVPNPolicy.PFSKeyGroup"] ~= "0") then
                    configRowVpn["IpsecVPNPolicy.PFSKeyGroup1"] = configRowVpn["IpsecVPNPolicy.PFSKeyGroup"]
                    configRowVpn["IpsecVPNPolicy.PFSKeyGroup"] = "1"
                else
                    configRowVpn["IpsecVPNPolicy.PFSKeyGroup1"] = "2"
                end
                if (configRowVpn["IpsecVPNPolicy.AddressFamily"] == "10") then
                    configRowVpn["IpsecVPNPolicy.RemoteEndPoint6"] = configRowVpn["IpsecVPNPolicy.RemoteEndPoint"]
                    configRowVpn["IpsecVPNPolicy.LocalStartAddress6"] = configRowVpn["IpsecVPNPolicy.LocalStartAddress"]
                    configRowVpn["IpsecVPNPolicy.LocalEndAddress6"] = configRowVpn["IpsecVPNPolicy.LocalEndAddress"]
                    configRowVpn["IpsecVPNPolicy.RemoteStartAddress6"] = configRowVpn["IpsecVPNPolicy.RemoteStartAddress"]
                    configRowVpn["IpsecVPNPolicy.RemoteEndAddress6"] = configRowVpn["IpsecVPNPolicy.RemoteEndAddress"]
                end
                if (configRowVpn["IpsecVPNPolicy.PolicyType"] == "1" and 
                    configRowVpn["IpsecVPNPolicy.AddressFamily"] == "10" and
                    configRowVpn["IpsecVPNPolicy.EnableKeepAlive"] == "1") then
                    configRowVpn["IpsecVPNPolicy.RemotePingIPAddress6"] = configRowVpn["IpsecVPNPolicy.RemotePingIPAddress"]
                end
        end
                return 1,configRowVpn

end
function ipsecVpnPolicyCfgSave(configRow)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	DBTable="IpsecVPNPolicy"	
    if (configRow["IpsecVPNPolicy.AddressFamily"] == "10") then
        if(configRow["IpsecVPNPolicy.RemoteEndPointType"] == "0") then
            configRow["IpsecVPNPolicy.RemoteEndPoint"] = configRow["IpsecVPNPolicy.RemoteEndPoint6"]
        end
        configRow["IpsecVPNPolicy.LocalStartAddress"] = configRow["IpsecVPNPolicy.LocalStartAddress6"]
        configRow["IpsecVPNPolicy.LocalEndAddress"] = configRow["IpsecVPNPolicy.LocalEndAddress6"]
        configRow["IpsecVPNPolicy.RemoteStartAddress"] = configRow["IpsecVPNPolicy.RemoteStartAddress6"]
        configRow["IpsecVPNPolicy.RemoteEndAddress"] = configRow["IpsecVPNPolicy.RemoteEndAddress6"]
    end
    for k,v in pairs(configRow) do
        if(v == nil or v == '') then
            v = nil
        end
    end
    configRow["IpsecVPNPolicy.RemoteEndPoint6"] = nil
    configRow["IpsecVPNPolicy.LocalStartAddress6"] = nil
    configRow["IpsecVPNPolicy.LocalEndAddress6"] = nil
    configRow["IpsecVPNPolicy.RemoteStartAddress6"] = nil
    configRow["IpsecVPNPolicy.RemoteEndAddress6"] = nil
    configRow["IpsecVPNPolicy.Direction"] = nil
    if (configRow["IpsecVPNPolicy.PolicyType"] == "1" and 
        configRow["IpsecVPNPolicy.AddressFamily"] == "10" and
        configRow["IpsecVPNPolicy.EnableKeepAlive"] == "1") then
        configRow["IpsecVPNPolicy.RemotePingIPAddress"] = configRow["IpsecVPNPolicy.RemotePingIPAddress6"]
    end
    configRow["IpsecVPNPolicy.RemotePingIPAddress6"] = nil

	if(configRow["IpsecVPNPolicy.PFSKeyGroup"] == "1") then
		configRow["IpsecVPNPolicy.PFSKeyGroup"] = configRow["IpsecVPNPolicy.PFSKeyGroup1"]
	end
    local RowId = db.getAttribute("IpsecVPNPolicy","VPNPolicyName",configRow["IpsecVPNPolicy.VPNPolicyName"],"_ROWID_")
	if (RowId == nil) then
	    errorFlag, statusCode = vipSecure.ipsecVPNPolicyConfig(configRow, "-1", "add")
	else
	    errorFlag, statusCode = vipSecure.ipsecVPNPolicyConfig(configRow, RowId, "edit")
	end
	-- save db if no error
	if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
	return errorFlag,statusMessage
   

end
function ipsecVpnPolicyCfgInputVal(configRow)
	local valid=true
    local ikeRow = ""

    if (configRow["IpsecVPNPolicy.AddressFamily"] == '' or configRow["IpsecVPNPolicy.AddressFamily"] == nil) then
        printCLIError("Invalid IP Version")
        return false
    end
    if (configRow["IpsecVPNPolicy.IKEPolicyName"] ~= nil) then
        local vpnRow = db.getRowWhere("IpsecVPNPolicy","IKEPolicyName='"..configRow["IpsecVPNPolicy.IKEPolicyName"].."' AND VPNPolicyName!='"..configRow["IpsecVPNPolicy.VPNPolicyName"].."'")
        if (vpnRow ~= nil) then
	        printCLIError(" Invalid IKE policy name, this IKE is using in other Policy ")
            return false
        end
    end
    if (configRow["IpsecVPNPolicy.IKEPolicyName"] ~= nil) then
        ikeRow = db.getRowWhere("IpsecIKEPolicy","IKEPolicyName='"..configRow["IpsecVPNPolicy.IKEPolicyName"].."'")
    end
    if ((configRow["IpsecVPNPolicy.IKEPolicyName"] == nil or ikeRow == nil) and configRow["IpsecVPNPolicy.PolicyType"] == "1") then
        printCLIError("Invalid IKE policy name,Please select from following IKE Policies")
        local ikeTable = db.getTable("IpsecIKEPolicy")
        local i = 0
        for k,v in pairs(ikeTable) do
            i = i + 1
            local ike = ikeTable[i]
            if (ike ~= nil) then
                print("'"..ike["IpsecIKEPolicy.IKEPolicyName"].."'")
            end
        end
        return false
    end
    if (configRow["IpsecVPNPolicy.PolicyType"] == "2" and configRow["IpsecVPNPolicy.RemoteEndPointType"] == "1")then
	    printCLIError("when manual policy selected remote end point type should be IPAddress")
	    return false
	end

    if (configRow["IpsecVPNPolicy.RemoteEndPointType"] == "0") then
        if (configRow["IpsecVPNPolicy.AddressFamily"] == "2") then
	        if (configRow["IpsecVPNPolicy.RemoteEndPoint"] == nil or configRow["IpsecVPNPolicy.RemoteEndPoint"] == "" or configRow["IpsecVPNPolicy.RemoteEndPoint"] == "0.0.0.0")then
		        printCLIError("Invalid IPAddress")
		        return false
            end
        elseif (configRow["IpsecVPNPolicy.AddressFamily"] == "10") then
	        if (configRow["IpsecVPNPolicy.RemoteEndPoint6"] == nil or configRow["IpsecVPNPolicy.RemoteEndPoint6"] == "")then
		        printCLIError("Invalid IPv6Address")
		        return false
            end
	    end
    elseif (configRow["IpsecVPNPolicy.RemoteEndPointType"] == "1") then
        if (configRow["IpsecVPNPolicy.RemoteEndPoint"] == nil or configRow["IpsecVPNPolicy.RemoteEndPoint"] == "")then
            printCLIError("Invalid FQDN.Please specify a Fully Qualified Domain Name for the remote endpoint")
		    return false
	        end
    end

	if (configRow["IpsecVPNPolicy.modeConfigStatus"] == "1" and configRow["IpsecVPNPolicy.PolicyType"] == "2")then
			printCLIError("Cannot enable Mode Config for manual policy")
			return false
	end
    if (configRow["IpsecVPNPolicy.modeConfigStatus"] == "1" and configRow["IpsecVPNPolicy.Netbios"] == "1")then
			printCLIError("Cannot enable NetBIOS when Mode Config enabled")
			return false
	end
	if (ipaddressValidate(configRow)) then else return false end
	if (configRow["IpsecVPNPolicy.PolicyType"] == "2")then --manual policy
		if (spiValidate(configRow)) then else return false end
		if (encryptAlgorithmValidate(configRow)) then else return false end
		if (authAlgorithmValidate(configRow)) then else return false end
		return true
	else 
		if (configRow["IpsecVPNPolicy.SALifeTime"] == nil or configRow["IpsecVPNPolicy.SALifeTime"] == "")then
		    printCLIError("Enter valid phase2 sa lifetime")
			return false
		end
--vpn encryption algo BLOWFISH validation
        if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "11")then
            if (configRow["IpsecVPNPolicy.KeyLength"] == nil or configRow["IpsecVPNPolicy.KeyLength"] == "") then
                printCLIError("Please enter a valid Key Length")
                return false
            end    
		    if (tonumber(configRow["IpsecVPNPolicy.KeyLength"]) < 40 or tonumber(configRow["IpsecVPNPolicy.KeyLength"]) > 448 or tonumber(configRow["IpsecVPNPolicy.KeyLength"])%8 ~= 0)then
			    printCLIError("Key length for BLOWFISH algorithm should be in between 40 and 448 and multiples of 8")
			    return false
		    end
	    end
--vpn encryption algo CAST128 validation
	    if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "12")then
            if (configRow["IpsecVPNPolicy.KeyLength"] == nil or configRow["IpsecVPNPolicy.KeyLength"] == "") then
                printCLIError("Please enter a valid Key Length")
                return false
            end
		    if (tonumber(configRow["IpsecVPNPolicy.KeyLength"]) < 40 or tonumber(configRow["IpsecVPNPolicy.KeyLength"]) > 128 or tonumber(configRow["IpsecVPNPolicy.KeyLength"])%8 ~= 0)then
			    printCLIError("Key length for CAST128 algorithm should be in between 40 and 128 and multiples of 8")
			    return false
		    end
	    end
        if(configRow["IpsecVPNPolicy.PFSKeyGroup1"] == nil or configRow["IpsecVPNPolicy.PFSKeyGroup1"] == "" or configRow["IpsecVPNPolicy.PFSKeyGroup1"] == "0" ) then    	
           configRow["IpsecVPNPolicy.PFSKeyGroup"] = "0"
        end
	end
    if (configRow["IpsecVPNPolicy.PolicyType"] == "2" and configRow["IpsecVPNPolicy.EnableKeepAlive"] == "1") then
        printCLIError("Keep Alive Enable Option Only for Auto Policy, Please disable enable_keepAlive option for Manual policy.")
        return false
    end
    if (configRow["IpsecVPNPolicy.PolicyType"] == "1" and configRow["IpsecVPNPolicy.EnableKeepAlive"] == "1") then
        if (configRow["IpsecVPNPolicy.AddressFamily"] == "2") then
            if (configRow["IpsecVPNPolicy.RemotePingIPAddress"] == '' or 
                configRow["IpsecVPNPolicy.RemotePingIPAddress"] == nil or
                configRow["IpsecVPNPolicy.RemotePingIPAddress"] == "0.0.0.0") then
                printCLIError("Invalid Ping IP address")
                return false
            end
        elseif (configRow["IpsecVPNPolicy.AddressFamily"] == "10") then
            if (configRow["IpsecVPNPolicy.RemotePingIPAddress6"] == '' or 
                configRow["IpsecVPNPolicy.RemotePingIPAddress6"] == nil) then
                printCLIError("Invalid Ping IP address6")
                return false
            end
        end
        if (configRow["IpsecVPNPolicy.KeepAlivePeriod"] == '' or configRow["IpsecVPNPolicy.KeepAlivePeriod"] == nil) then
            printCLIError("Invalid Keep Alive Period")
            return false
        end
        if (configRow["IpsecVPNPolicy.KeepAliveFailureCount"] == '' or configRow["IpsecVPNPolicy.KeepAliveFailureCount"] == nil) then
            printCLIError("Invalid Keep Alive failure count")
            return false
        end
    end
    if (configRow["IpsecVPNPolicy.SALifeTimeType"] == "0") then
        if (tonumber(configRow["IpsecVPNPolicy.SALifeTime"]) < 300) then
            printCLIError("Invalid SA Life time value. Please enter a value not less than 300 seconds")
            return false
        end
    elseif (configRow["IpsecVPNPolicy.SALifeTimeType"] == "1") then
        if (tonumber(configRow["IpsecVPNPolicy.SALifeTime"]) < 1920000) then
            printCLIError("Invalid SA Life time value. Please enter a value not less than 1920000 Kbytes")
            return false
        end
    end
    if (configRow ["IpsecVPNPolicy.Rollover"] == "1") then
        if (configRow ["IpsecVPNPolicy.RolloverGateway"] == "" or configRow ["IpsecVPNPolicy.RolloverGateway"] == nil) then
            printCLIError("Invalid rollover gateway")
            return false
        end
        if (configRow ["IpsecVPNPolicy.RolloverGateway"] == configRow ["IpsecVPNPolicy.LocalGateway"]) then
            printCLIError("Please select rollover gateway other than WAN" .. (tonumber(configRow ["IpsecVPNPolicy.LocalGateway"]) + 1 ))
            return false
        end
    end
	return true
end

function ipaddressValidate(configRow)
    if (configRow["IpsecVPNPolicy.AddressFamily"] == "2") then
    if (configRow["IpsecVPNPolicy.modeConfigStatus"] == "1") then
        if (configRow["IpsecVPNPolicy.LocalNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.LocalStartAddress"] == nil or configRow["IpsecVPNPolicy.LocalStartAddress"] == "" or configRow["IpsecVPNPolicy.LocalStartAddress"] == "0.0.0.0"))then
			printCLIError("Invalid local start ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "2" and (configRow["IpsecVPNPolicy.LocalEndAddress"] == nil or configRow["IpsecVPNPolicy.LocalEndAddress"] == "" or configRow["IpsecVPNPolicy.LocalEndAddress"] == "0.0.0.0"))then
			printCLIError("Invalid local end IPAddress")	
			return false
		end
		if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "3" and (configRow["IpsecVPNPolicy.LocalSubnetMask"] == nil or configRow["IpsecVPNPolicy.LocalSubnetMask"] == "" or configRow["IpsecVPNPolicy.LocalSubnetMask"] == "0.0.0.0"))then
		    printCLIError("Invalid local subnet mask")	
		    return false
		end
    else
	    if (configRow["IpsecVPNPolicy.LocalNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.LocalStartAddress"] == nil or configRow["IpsecVPNPolicy.LocalStartAddress"] == "" or configRow["IpsecVPNPolicy.LocalStartAddress"] == "0.0.0.0"))then
			printCLIError("Invalid local start ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "2" and (configRow["IpsecVPNPolicy.LocalEndAddress"] == nil or configRow["IpsecVPNPolicy.LocalEndAddress"] == "" or configRow["IpsecVPNPolicy.LocalEndAddress"] == "0.0.0.0"))then
			printCLIError("Invalid local end ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "3" and (configRow["IpsecVPNPolicy.LocalSubnetMask"] == nil or configRow["IpsecVPNPolicy.LocalSubnetMask"] == "" or configRow["IpsecVPNPolicy.LocalSubnetMask"] == "0.0.0.0"))then
		    printCLIError("Invalid local subnet mask")	
		    return false
		end
    end

		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.RemoteStartAddress"] == nil or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "" or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "0.0.0.0"))then
			printCLIError("Invalid remote start ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] == "2" and (configRow["IpsecVPNPolicy.RemoteEndAddress"] == nil or configRow["IpsecVPNPolicy.RemoteEndAddress"] == "" or configRow["IpsecVPNPolicy.RemoteEndAddress"] == "0.0.0.0"))then
			printCLIError("Invalid remote end ip address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] == "3" and (configRow["IpsecVPNPolicy.RemoteSubnetMask"] == nil or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "" or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "0.0.0.0"))then
		    printCLIError("Invalid remote subnet mask")	
		    return false
		end
    elseif (configRow["IpsecVPNPolicy.AddressFamily"] == "10") then
        if (configRow["IpsecVPNPolicy.modeConfigStatus"] == "1") then
            if (configRow["IpsecVPNPolicy.LocalNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.LocalStartAddress6"] == nil or configRow["IpsecVPNPolicy.LocalStartAddress6"] == ""))then
			    printCLIError("Invalid local start ipv6 address")	
			    return false
		    end
		    if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "2" and (configRow["IpsecVPNPolicy.LocalEndAddress6"] == nil or configRow["IpsecVPNPolicy.LocalEndAddress6"] == ""))then
			    printCLIError("Invalid local end IPv6Address")	
			    return false
		    end
            if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "3" and (configRow["IpsecVPNPolicy.LocalPrefixLength"] == nil or configRow["IpsecVPNPolicy.LocalPrefixLength"] == "" or tonumber(configRow["IpsecVPNPolicy.LocalPrefixLength"]) < 1 or tonumber(configRow["IpsecVPNPolicy.LocalPrefixLength"]) > 128))then
			    printCLIError("Invalid local prefix length")	
			    return false
            end
        else
	        if (configRow["IpsecVPNPolicy.LocalNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.LocalStartAddress6"] == nil or configRow["IpsecVPNPolicy.LocalStartAddress6"] == ""))then
			    printCLIError("Invalid local start ipv6 address")	
			    return false
		    end
		    if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "2" and (configRow["IpsecVPNPolicy.LocalEndAddress6"] == nil or configRow["IpsecVPNPolicy.LocalEndAddress6"] == ""))then
			    printCLIError("Invalid local end ipv6 address")	
			    return false
		    end
            if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "3" and (configRow["IpsecVPNPolicy.LocalPrefixLength"] == nil or configRow["IpsecVPNPolicy.LocalPrefixLength"] == "" or tonumber(configRow["IpsecVPNPolicy.LocalPrefixLength"]) < 1 or tonumber(configRow["IpsecVPNPolicy.LocalPrefixLength"]) > 128))then
			    printCLIError("Invalid local prefix length")	
			    return false
		    end
        end

		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] ~= "0" and (configRow["IpsecVPNPolicy.RemoteStartAddress6"] == nil or configRow["IpsecVPNPolicy.RemoteStartAddress6"] == ""))then
			printCLIError("Invalid remote start ipv6 address")	
			return false
		end
		if (configRow["IpsecVPNPolicy.RemoteNetworkType"] == "2" and (configRow["IpsecVPNPolicy.RemoteEndAddress6"] == nil or configRow["IpsecVPNPolicy.RemoteEndAddress6"] == ""))then
			printCLIError("Invalid remote end ipv6 address")	
			return false
		end
        if (configRow["IpsecVPNPolicy.RemoteNetworkType"] == "3" and (configRow["IpsecVPNPolicy.RemotePrefixLength"] == nil or configRow["IpsecVPNPolicy.RemotePrefixLength"] == "" or tonumber(configRow["IpsecVPNPolicy.RemotePrefixLength"]) < 1 or tonumber(configRow["IpsecVPNPolicy.RemotePrefixLength"]) > 128))then
		    printCLIError("Invalid remote prefix length")	
		    return false
		end
    end

    if(configRow["IpsecVPNPolicy.Netbios"] == "1" and configRow["IpsecVPNPolicy.RemoteNetworkType"] ~= "3") then
        printCLIError("Netbios is enable so general_remote_network_type must be SUBNET")
        return false
    end
	if(configRow["IpsecVPNPolicy.Netbios"] == "1") then
        configRow["IpsecVPNPolicy.RemoteNetworkType"] = "3"
		if (configRow["IpsecVPNPolicy.AddressFamily"] == "2") then
	        if (configRow["IpsecVPNPolicy.RemoteSubnetMask"] == nil or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "" or configRow["IpsecVPNPolicy.RemoteSubnetMask"] == "0.0.0.0")then
		        printCLIError("Invalid remote subnet mask (as netbios is enable so remote network type is Subnet")	
		        return false
            end
            if (configRow["IpsecVPNPolicy.RemoteStartAddress"] == nil or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "" or configRow["IpsecVPNPolicy.RemoteStartAddress"] == "0.0.0.0")then
		        printCLIError("Invalid remote start ip address")	
		        return false
		    end
        elseif (configRow["IpsecVPNPolicy.AddressFamily"] == "10") then
            if (configRow["IpsecVPNPolicy.RemotePrefixLength"] == nil or configRow["IpsecVPNPolicy.RemotePrefixLength"] == "" or tonumber(configRow["IpsecVPNPolicy.RemotePrefixLength"]) < 1 or tonumber(configRow["IpsecVPNPolicy.RemotePrefixLength"]) > 128)then
		        printCLIError("Invalid remote prefix length")	
		        return false
            end
            if (configRow["IpsecVPNPolicy.RemoteStartAddress6"] == nil or configRow["IpsecVPNPolicy.RemoteStartAddress6"] == "")then
		        printCLIError("Invalid remote start ipv6 address")	
		        return false
		    end
	    end
    end
    --if (configRow["IpsecVPNPolicy.LocalNetworkType"] == "0" and configRow["IpsecVPNPolicy.RemoteNetworkType"] == "0") then
        --printCLIError("Both local network type and remote network type cannot be ANY")
        --return false
    --end
return true
end
function encryptAlgorithmValidate(configRow)
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] ~= "0")then
		if (configRow["IpsecVPNPolicy.EncryptionKeyIn"] == nil or configRow["IpsecVPNPolicy.EncryptionKeyIn"] == "")then
			printCLIError("Invalid key in for encryption algorithm")	
			return false
		end
		if (configRow["IpsecVPNPolicy.EncryptionKeyOut"] == nil or configRow["IpsecVPNPolicy.EncryptionKeyOut"] == "")then
			printCLIError("Invalid key out for encryption algorithm")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] ~= "6" or configRow["IpsecVPNPolicy.EncryptionAlgorithm"] ~= "7")then
		if (configRow["IpsecVPNPolicy.AuthKeyIn"] == nil or configRow["IpsecVPNPolicy.AuthKeyIn"] == "")then
			printCLIError("Invalid key in for integrity algorithm")	
			return false
		end
		if (configRow["IpsecVPNPolicy.AuthKeyOut"] == nil or configRow["IpsecVPNPolicy.AuthKeyOut"] == "")then
			printCLIError("Invalid key in for integrity algorithm")	
			return false
		end
	end	
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "2")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 24)then 
			printCLIError("Invalid key in length for 3DES encryption algorithm should be of length 24")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 24)then 
			printCLIError("Invalid key out length for 3DES encryption algorithm should be of length 24")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "1")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 8)then 
			printCLIError("Invalid key in length for DES encryption algorithm should be of length 8")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 8)then 
			printCLIError("Invalid key out length for DES encryption algorithm should be of length 8")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "3")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 16)then 
			printCLIError("Invalid key in length for AES-128 encryption algorithm should be of length 16")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 16)then 
			printCLIError("Invalid key out length for AES-128 encryption algorithm should be of length 16")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "4")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 24)then 
			printCLIError("Invalid key in length for AES-192 encryption algorithm should be of length 24")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 24)then 
			printCLIError("Invalid key out length for AES-192 encryption algorithm should be of length 24")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "5")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 32)then 
			printCLIError("Invalid key in length for AES-256 encryption algorithm should be of length 32")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 32)then 
			printCLIError("Invalid key out length for AES-256 encryption algorithm should be of length 32")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "6")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 16)then 
			printCLIError("Invalid key in length for AES-CCM encryption algorithm should be of length 16")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 16)then 
			printCLIError("Invalid key out length for AES-CCM encryption algorithm should be of length 16")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "7")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 20)then 
			printCLIError("Invalid key in length for AES-GCM encryption algorithm should be of length 20")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 20)then 
			printCLIError("Invalid key out length for AES-GCM encryption algorithm should be of length 20")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "8")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 16)then 
			printCLIError("Invalid key in length for TWOFISH (128) encryption algorithm should be of length 16")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 16)then 
			printCLIError("Invalid key out length for TWOFISH (128) encryption algorithm should be of length 16")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "9")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 24)then 
			printCLIError("Invalid key in length for TWOFISH (192) encryption algorithm should be of length 24")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 24)then 
			printCLIError("Invalid key out length for TWOFISH (192) encryption algorithm should be of length 24")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "10")then
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= 32)then 
			printCLIError("Invalid key in length for TWOFISH (256) encryption algorithm should be of length 32")	
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= 32)then 
			printCLIError("Invalid key out length for TWOFISH (256) encryption algorithm should be of length 32")	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "11")then
        if (configRow["IpsecVPNPolicy.KeyLength"] == nil or configRow["IpsecVPNPolicy.KeyLength"] == "") then
            printCLIError("Please enter a valid Key Length")
            return false
        end    
		if (tonumber(configRow["IpsecVPNPolicy.KeyLength"]) < 40 or tonumber(configRow["IpsecVPNPolicy.KeyLength"]) > 448 or tonumber(configRow["IpsecVPNPolicy.KeyLength"])%8 ~= 0)then
			printCLIError("Key length for BLOWFISH algorithm should be in between 40 and 448 and multiples of 8")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key in length for BLOWFISH encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key out length for BLOWFISH encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)	
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.EncryptionAlgorithm"] == "12")then
        if (configRow["IpsecVPNPolicy.KeyLength"] == nil or configRow["IpsecVPNPolicy.KeyLength"] == "") then
            printCLIError("Please enter a valid Key Length")
            return false
        end 
		if (tonumber(configRow["IpsecVPNPolicy.KeyLength"]) < 40 or tonumber(configRow["IpsecVPNPolicy.KeyLength"]) > 128 or tonumber(configRow["IpsecVPNPolicy.KeyLength"])%8 ~= 0)then
			printCLIError("Key length for CAST128 algorithm should be in between 40 and 128 and multiples of 8")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyIn"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key in length for CAST128 encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.EncryptionKeyOut"]) ~= (tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8))then 
			printCLIError("Invalid key out length for CAST128 encryption algorithm should be of length "..tonumber(configRow["IpsecVPNPolicy.KeyLength"])/8)	
			return false
		end
	end

	return true
end
function authAlgorithmValidate(configRow)
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] ~= "0")then
		if (configRow["IpsecVPNPolicy.AuthKeyIn"] == nil or configRow["IpsecVPNPolicy.AuthKeyIn"] == "")then
			printCLIError("Invalid key in for authentication algorithm")	
			return false
		end
		if (configRow["IpsecVPNPolicy.AuthKeyOut"] == nil or configRow["IpsecVPNPolicy.AuthKeyOut"] == "")then
			printCLIError("Invalid key out for authentication algorithm")	
			return false
		end
	end


	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "2")then

		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 20)then
			printCLIError("Invalid key in length for SHA-1 authentication should be of length 20")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 20)then
			printCLIError("Invalid key out length for SHA-1 authentication should be of length 20")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "6")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 24)then
			printCLIError("Invalid key in length for SHA2-224 authentication should be of length 24")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 24)then
			printCLIError("Invalid key out length for SHA2-224 authentication should be of length 24")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "3")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 32)then
			printCLIError("Invalid key in length for SHA2-256 authentication should be of length 32")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 32)then
			printCLIError("Invalid key out length for SHA2-256 authentication should be of length 32")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "4")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 48)then
			printCLIError("Invalid key in length for SHA2-384 authentication should be of length 48")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 48)then
			printCLIError("Invalid key out length for SHA2-384 authentication should be of length 48")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "5")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 64)then
			printCLIError("Invalid key in length for SHA2-512 authentication should be of length 64")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 64)then
			printCLIError("Invalid key out length for SHA2-512 authentication should be of length 64")
			return false
		end
	end
	if (configRow["IpsecVPNPolicy.AuthAlgorithm"] == "1")then
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyIn"]) ~= 16)then
			printCLIError("Invalid key in length for MD5 authentication should be of length 16")
			return false
		end
		if (string.len(configRow["IpsecVPNPolicy.AuthKeyOut"]) ~= 16)then
			printCLIError("Invalid key out length for MD5 authentication should be of length 16")
			return false
		end
	end
	return true
end
function spiValidate(configRow)
	if (configRow["IpsecVPNPolicy.SPIIn"] == nil or configRow["IpsecVPNPolicy.SPIIn"] == "")then
			printCLIError("Invalid spi_in value")	
			return false
    else
        configRow["IpsecVPNPolicy.SPIIn"] = configRow["IpsecVPNPolicy.SPIIn"]
	end
	if (string.len(configRow["IpsecVPNPolicy.SPIIn"]) > 15)then
			printCLIError("Invalid spi_in value length cannot be more than 13")	
			return false
	end
	if (configRow["IpsecVPNPolicy.SPIOut"] == nil or configRow["IpsecVPNPolicy.SPIOut"] == "")then
			printCLIError("Invalid spi_out value")	
			return false
    else
         configRow["IpsecVPNPolicy.SPIOut"] = configRow["IpsecVPNPolicy.SPIOut"]
	end
	if (string.len(configRow["IpsecVPNPolicy.SPIOut"]) > 15)then
			printCLIError("Invalid spi_out value length cannot be more than 13")	
			return false
	end
return true
end
function ipsecVpnPolicyEnable(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])

	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		    local rows = {}
    		    rows["rowid"] = configRow["IpsecVPNPolicy._ROWID_"]	
		    errorFlag, statusCode = vipSecure.ipsecVPNPolicyEnable(rows, true)
	end
        if (errorFlag == "OK") then db.save() end
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
	return errorFlag,statusMessage	
end
function ipsecVpnPolicyDisable(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])
	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		    local rows = {}
    		    rows["rowid"] = configRow["IpsecVPNPolicy._ROWID_"]	
		    errorFlag, statusCode = vipSecure.ipsecVPNPolicyEnable(rows, false)
	end
        if (errorFlag == "OK") then db.save() end
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    print(statusMessage)
	return errorFlag,statusMessage	
end
function ipsecVpnPolicyDelete(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecVPNPolicy","VPNPolicyName",args[1])
	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		local rows = {}
        rows["rowid"] = configRow["IpsecVPNPolicy._ROWID_"]	
        errorFlag, statusCode = vipSecure.ipsecVPNPolicyDelete(rows)
		if (errorFlag == "OK") then
			db.commitTransaction(true) 
			db.save()						 
		end
		statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
	end
    print(statusMessage)
	return errorFlag,statusMessage
end
-- function for showing ipsec vpn logs

function ipsecVpnLogsGet()
	os.execute("cat /var/racoon.log |tail -n50")
	return true
end

function ipsecVpnPolicyGet()
local resultTab = {}
local i=0
	local table = db.getTable("IpsecVPNPolicy")
	for k,v in pairs(table) do
		i = i + 1
		local row = table[i]
		local status
		if (row["IpsecVPNPolicy.Status"] == "0")then
			status = "Disabled"
		else
			status="Enabled"
		end
		resTab.insertField (resultTab,"Status",status)
		resTab.insertField (resultTab,"Name",row["IpsecVPNPolicy.VPNPolicyName"])
		local PolicyType = ""
		if(row["IpsecVPNPolicy.PolicyType"] == "1") then
	  		PolicyType = "Auto Policy"
		elseif(row["IpsecVPNPolicy.PolicyType"] == "2") then
			PolicyType = "Manual Policy"
		end
		resTab.insertField (resultTab,"Type",PolicyType)
		local IpsecMode = ""
		if(row["IpsecVPNPolicy.TunnelOrTransport"] == "0") then
			IpsecMode = "Transport Mode"
		elseif(row["IpsecVPNPolicy.TunnelOrTransport"] == "1") then
			IpsecMode = "Tunnel Mode"
		end
		resTab.insertField (resultTab,"IPSec Mode",IpsecMode)
        if(row["IpsecVPNPolicy.Netbios"] == "0") then
            Netbios = "Disabled"
        else
            Netbios = "Enabled"
        end
        resTab.insertField (resultTab, "NetBIOS", Netbios)
		if(row["IpsecVPNPolicy.LocalNetworkType"] == "0") then
			Localtype = "Any"
		elseif(row["IpsecVPNPolicy.LocalNetworkType"] == "1") then
			Localtype = row["IpsecVPNPolicy.LocalStartAddress"]
		elseif(row["IpsecVPNPolicy.LocalNetworkType"] == "2") then
    	    Localtype = row["IpsecVPNPolicy.LocalStartAddress"]  ..  " - " .. row["IpsecVPNPolicy.LocalEndAddress"]
		elseif(row["IpsecVPNPolicy.LocalNetworkType"] == "3") then
            if(row["IpsecVPNPolicy.AddressFamily"] == "2") then
            	Localtype = row["IpsecVPNPolicy.LocalStartAddress"] .. " / " .. row["IpsecVPNPolicy.LocalSubnetMask"]
            elseif(row["IpsecVPNPolicy.AddressFamily"] == "10") then
                Localtype = row["IpsecVPNPolicy.LocalStartAddress"] .. " / " .. row["IpsecVPNPolicy.LocalPrefixLength"]
            end
		end
		resTab.insertField (resultTab,"Local",Localtype)
		local Remotetype = ""
       	if(row["IpsecVPNPolicy.RemoteNetworkType"] == "0") then
       	 	Remotetype = "Any"
       	elseif(row["IpsecVPNPolicy.RemoteNetworkType"] == "1") then
       		Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"]
       	elseif(row["IpsecVPNPolicy.RemoteNetworkType"] == "2") then
       	 	Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"]  ..  " - " .. row["IpsecVPNPolicy.RemoteEndAddress"]
       	elseif(row["IpsecVPNPolicy.RemoteNetworkType"] == "3") then
            if(row["IpsecVPNPolicy.AddressFamily"] == "2") then
           	 	Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"] .. " / " .. row["IpsecVPNPolicy.RemoteSubnetMask"]
            elseif(row["IpsecVPNPolicy.AddressFamily"] == "10") then
                Remotetype = row["IpsecVPNPolicy.RemoteStartAddress"] .. " / " .. row["IpsecVPNPolicy.RemotePrefixLength"]
            end
		end
		resTab.insertField (resultTab,"Remote",Remotetype)
		local AuthType = ""
	       	if(row["IpsecVPNPolicy.AuthAlgorithm"] == "6") then
			AuthType = "SHA2-224"
        	elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "7") then
	       		AuthType = "NONE"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "2") then
	               	AuthType = "SHA-1"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "1") then
	               	AuthType = "MD5"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "3") then
	               	AuthType = "SHA2-256"
	        elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "4") then
	               	AuthType = "SHA2-384"
		elseif(row["IpsecVPNPolicy.AuthAlgorithm"] == "5") then
	               	AuthType = "SHA2-512"
		end
		resTab.insertField (resultTab,"Auth",AuthType)
		local EncrType = ""
	       	if(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "0") then
	               	EncrType = "None"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "1") then
	               	EncrType = "DES"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "2") then
	               	EncrType = "3DES"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "3") then
	               	EncrType = "AES-128"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "4") then
	               	EncrType = "AES-192"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "5") then
	               	EncrType = "AES-256"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "6") then
	               	EncrType = "AES-CCM"
	       	elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "7") then
	               	EncrType = "AES-GCM"
	        elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "8") then
	              	EncrType = "TWOFISH (128)"
	        elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "9") then
	              	EncrType = "TWOFISH (192)"
	        elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "10") then
	              	EncrType = "TWOFISH (256)"
		elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "11") then
	               	EncrType = "BLOWFISH"
		elseif(row["IpsecVPNPolicy.EncryptionAlgorithm"] == "12") then
	               	EncrType = "CAST128"
		end
		resTab.insertField (resultTab,"Encr",EncrType)
   	end
resTab.print (resultTab, 0)
end

function ipsecVpnDhcpCfgInit(args)
configRow = db.getRow("IPsecDhcpClientIPRange", "IPsecDhcpClientIPRange._ROWID_", "1")
return 1,configRow
end
function ipsecVpnDhcpCfgSave(configRow)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	DBTable="IPsecDhcpClientIPRange"	
	errorFlag, statusCode = dhcpOverIpsec.config(configRow,"1", "edit")
	if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
	return errorFlag,statusMessage	
end
function ipsecVpnDhcpCfgInputVal(confgRow)
	if (configRow["IPsecDhcpClientIPRange.StartIPAddress"] == nil or configRow["IPsecDhcpClientIPRange.StartIPAddress"] == "" or configRow["IPsecDhcpClientIPRange.StartIPAddress"] == "0.0.0.0")then
		printCLIError("Enter valid start address")
		return false
	end
	if (configRow["IPsecDhcpClientIPRange.EndIPAddress"] == nil or configRow["IPsecDhcpClientIPRange.EndIPAddress"] == "" or configRow["IPsecDhcpClientIPRange.EndIPAddress"] == "0.0.0.0")then
		printCLIError("Enter valid end address")
		return false
	end
	if (configRow["IPsecDhcpClientIPRange.SubnetMask"] == nil or configRow["IPsecDhcpClientIPRange.SubnetMask"] == "" or configRow["IPsecDhcpClientIPRange.SubnetMask"] == "0.0.0.0")then
		printCLIError("Enter valid subnet mask")
		return false
	end
end
function ipsecVpnDhcpGet()
configRow = db.getRow("IPsecDhcpClientIPRange", "IPsecDhcpClientIPRange._ROWID_", "1")
printLabel("IP Range For DHCP Over IPsec")
print("Starting IP Address:",configRow["IPsecDhcpClientIPRange.StartIPAddress"])
print("Ending IP Address:",configRow["IPsecDhcpClientIPRange.EndIPAddress"])
print("Subnet Mask:",configRow["IPsecDhcpClientIPRange.SubnetMask"])
end

function ipsecVpnPolicyConnect(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
    local prog = db.getAttribute("environment", "name", "VIPSECURE_STATUS", "value")
    if (prog ~= nil) then
        os.execute(prog .. " " .. "/tmp/system.db")
    end
    if (db.existsRow("ConnectionStatus", "PolicyName", args[1])) then
        local rowid = db.getAttribute("ConnectionStatus","PolicyName",args[1],"_ROWID_")
        errorFlag, statusCode = vipSecure.ConnStatusConfig ("ConnectionStatus", "_ROWID_", rowid, "Action", "1", "Connect")
        if (errorFlag == "OK") then
	        db.commitTransaction(true) 
		    db.save()						 
	    end
	    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
	    return errorFlag,statusMessage
    else
        printCLIError("No Policy with this name exists")
        return false
    end
end

function ipsecVpnPolicyDrop(args)
	errorFlag="ERROR"
	statusCode=""
	statusMessage=""
    local prog = db.getAttribute("environment", "name", "VIPSECURE_STATUS", "value")
    if (prog ~= nil) then
        os.execute(prog .. " " .. "/tmp/system.db")
    end
    if (db.existsRow("ConnectionStatus", "PolicyName", args[1])) then
        local rowid = db.getAttribute("ConnectionStatus","PolicyName",args[1],"_ROWID_")
        errorFlag, statusCode = vipSecure.ConnStatusConfig ("ConnectionStatus", "_ROWID_",rowid, "Action", "0","Drop")
	    if (errorFlag == "OK") then
		    db.commitTransaction(true) 
		    db.save()						 
	    end
	    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
	    return errorFlag,statusMessage
    else
        printCLIError("No Policy with this name exists")
        return false
    end
end
function ipsecVpnPolicyStatusGet()
    local prog = db.getAttribute("environment", "name", "VIPSECURE_STATUS", "value")
    if (prog ~= nil) then
        os.execute(prog .. " " .. "/tmp/system.db")
    end
    
    local resultTab = {}
    local i=0
	local table = db.getTable("ConnectionStatus")
	for k,v in pairs(table) do
		i = i + 1
		local row = table[i]
        resTab.insertField (resultTab,"Row Id",row["ConnectionStatus._ROWID_"])
		resTab.insertField (resultTab,"Policy Name",row["ConnectionStatus.PolicyName"])
		resTab.insertField (resultTab,"Endpoint",row["ConnectionStatus.RemoteEndpoint"])
		resTab.insertField (resultTab,"tx ( KB )",row["ConnectionStatus.TxData"])
		resTab.insertField (resultTab,"tx ( Packets )",row["ConnectionStatus.TxPackets"])
		resTab.insertField (resultTab,"UP Time (seconds)",row["ConnectionStatus.upTime"])
		resTab.insertField (resultTab,"State",row["ConnectionStatus.ConnectionStatus"])
        local Action = ""
        if (row["ConnectionStatus.Action"] ~= nil and row["ConnectionStatus.Action"] == "1") then
            Action = "Drop"    
        else 
            Action = "Connect"    
        end
		resTab.insertField (resultTab,"Action",Action)
   	end
resTab.print (resultTab, 0)
end


function vpnWizardCfgInit(args)
    local configRow = {}
    configRow ["vpnConfig.Peer"] = args[1]
    configRow ["vpnConfig.LocalGateway"] = "0"
    configRow ["vpnConfig.Rollover"] = "0"
    return rowId, configRow
end
function vpnWizardCfgInputVal(configRow)
    if (configRow ["vpnConfig.ConnectionName"] == '' or configRow ["vpnConfig.ConnectionName"] == nil) then
        printCLIError("Invalid connection name")
        return false
    end
    if (configRow ["vpnConfig.PresharedKey"] == '' or configRow ["vpnConfig.PresharedKey"] == nil) then
        printCLIError("Invalid Preshared Key")
        return false
    end
    if (configRow["vpnConfig.AddressFamily"] == '' or configRow["vpnConfig.AddressFamily"] == nil) then
        printCLIError("Invalid IP Version")
        return false
    end
    if (configRow ["vpnConfig.RemoteIdentifier"] == '' or configRow ["vpnConfig.RemoteIdentifier"] == nil) then
        printCLIError("Invalid Remote Identifier")
        return false
    end
    if (configRow ["vpnConfig.LocalIdentifier"] == '' or configRow ["vpnConfig.LocalIdentifier"] == nil) then
        printCLIError("Invalid Local Identifier")
        return false
    end
    if (configRow ["vpnConfig.Peer"] == "0") then
        if (configRow ["vpnConfig.AddressFamily"] == "2") then
            if (configRow ["vpnConfig.RemoteIP"] == '' or 
                configRow ["vpnConfig.RemoteIP"] == nil or
                configRow ["vpnConfig.RemoteIP"] == "0.0.0.0") then
                printCLIError ("Invalid remote LAN IP address")
                return false
            end
            if (configRow ["vpnConfig.RemoteSubnet"] == '' or 
                configRow ["vpnConfig.RemoteSubnet"] == nil or
                configRow ["vpnConfig.RemoteSubnet"] == "0.0.0.0") then
                printCLIError ("Invalid remote Subnet Mask ")
                return false
            end
        elseif (configRow ["vpnConfig.AddressFamily"] == "10") then
            if (configRow ["vpnConfig.RemoteIP6"] == '' or 
                configRow ["vpnConfig.RemoteIP6"] == nil) then
                printCLIError ("Invalid remote LAN IPv6 address")
                return false
            end
            if (configRow ["vpnConfig.RemotePrefixLength"] == '' or 
                configRow ["vpnConfig.RemotePrefixLength"] == nil or
                tonumber(configRow ["vpnConfig.RemotePrefixLength"]) < 1 or
                tonumber(configRow ["vpnConfig.RemotePrefixLength"]) > 128) then
                printCLIError ("Invalid remote lan prefix length ")
                return false
            end
        end
    end
    if (db.existsRow("IpsecVPNPolicy", "RemoteEndPoint", configRow["vpnConfig.RemoteIdentifier"])) then
    	printCLIError("Policy with same remote identifier exists")
        return false
    end

    if (db.existsRow("IpsecIKEPolicy", "IKEPolicyName", configRow["vpnConfig.ConnectionName"])) then
	    printCLIError(" IKE Policy with same connection name exists ")
        return false
    end

    if (db.existsRow("IpsecVPNPolicy", "VPNPolicyName", configRow["vpnConfig.ConnectionName"])) then
    	printCLIError("VPN Policy with same connection name exists")
        return false
    end
    if (configRow ["vpnConfig.Rollover"] == "1") then
        if (configRow ["vpnConfig.RolloverGateway"] == "" or configRow ["vpnConfig.RolloverGateway"] == nil) then
            printCLIError("Invalid rollover gateway")
            return false
        end
        if (configRow ["vpnConfig.RolloverGateway"] == configRow ["vpnConfig.LocalGateway"]) then
            printCLIError("Please select rollover gateway other than WAN" .. (tonumber(configRow ["vpnConfig.LocalGateway"]) + 1 ))
            return false
        end
    end
    return true
end

function vpnWizardCfgSave(configRow)
    errorFlag="ERROR"
	statusCode=""
	statusMessage=""
    local ikeTable = db.getTable("IpsecIKEPolicy")
    local vpnTable = db.getTable("IpsecVPNPolicy")
    if (configRow ["vpnConfig.AddressFamily"] == "10") then
        configRow ["vpnConfig.RemoteIP"] = configRow ["vpnConfig.RemoteIP6"]
    end
    configRow ["vpnConfig.RemoteIP6"] = nil
    if((#ikeTable ~= nil and #ikeTable >= 5) or (#vpnTable ~= nil and #vpnTable >= 15)) then
    	printCLIError("Can't add configuration to this table. Maximum limit reached.")
        return false
	else
	    errorFlag, statusCode = vipSecure.wizardConfig (configRow, "-1", "add")
	    -- save db if no error
        if (errorFlag == "OK") then db.save() end
		statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
        print(statusMessage)
	end
end

function ipsecIkePolicyCfgInit(args)
    local configRow = db.getRow ("IpsecIKEPolicy","IKEPolicyName",args[1])
    if (configRow == nil) then
        configRow = {}
        configRow ["IpsecIKEPolicy.IKEPolicyName"] = args[1]
        configRow ["IpsecIKEPolicy.ModeConfigStatus"] = "0"
        configRow ["IpsecIKEPolicy.Direction"] = "2"
        configRow ["IpsecIKEPolicy.ExchangeMode"] = "0"
        configRow ["IpsecIKEPolicy.LocalIdentifierType"] = "0"
        configRow ["IpsecIKEPolicy.RemoteIdentifierType"] = "0"
        configRow ["IpsecIKEPolicy.EncryptionAlgorithm"] = "2"
        configRow ["IpsecIKEPolicy.AuthAlgorithm"] = "2"
        configRow ["IpsecIKEPolicy.AuthType"] = "0"
        configRow ["IpsecIKEPolicy.DHGroup"] = "2"
        configRow ["IpsecIKEPolicy.SALifeTime"] = "28800"
        configRow ["IpsecIKEPolicy.DPD"] = "0"
        configRow ["IpsecIKEPolicy.DPDDetectionPeriod"] = "10"
        configRow ["IpsecIKEPolicy.DPDFailureCount"] = "3"
        configRow ["IpsecIKEPolicy.XAUTHType"] = "0"
        configRow ["IpsecIKEPolicy.IKEVersion"] = "1"
        configRow ["IpsecIKEPolicy.NatTraversal"] = "1"
        configRow ["IpsecIKEPolicy.NatKeepAliveTime"] = "10"
        configRow ["IpsecIKEPolicy.LocalGateway"] = "0"
    elseif (configRow["IpsecIKEPolicy.XAUTHType"] ~= nil and tonumber(configRow["IpsecIKEPolicy.XAUTHType"]) > 1) then
 		configRow["IpsecIKEPolicy.XAUTHType1"] = configRow["IpsecIKEPolicy.XAUTHType"]
 		configRow["IpsecIKEPolicy.XAUTHType"] = "2"
    end
    return rowId, configRow
end

function ipsecIkePolicyCfgInputVal(configRow)
    if (configRow["IpsecIKEPolicy.AddressFamily"] == '' or configRow["IpsecIKEPolicy.AddressFamily"] == nil) then
        printCLIError("Invalid IP Version")
        return false
    end
    if (configRow ["IpsecIKEPolicy.ModeConfigStatus"] == "1") then
        if (configRow["IpsecIKEPolicy.ModeConfigRecordName"] == '' or configRow["IpsecIKEPolicy.ModeConfigRecordName"] == nil) then
            printCLIError("Invalid Mode Config Record Name.")
            local i = 0
			local table = db.getTable("IpsecModeConfigVpnPolicy")
		    if(#table ~= 0) then
                print("Please select from the following Mode Config Record")
				for k,v in pairs(table) do
					i = i + 1
					local row = table[i]
                    if (row ~= nil) then
                        print("'"..row["IpsecModeConfigVpnPolicy.ModeConfigRecordName"].."'")
                    end
                end
            else
                print("No Mode Config Record available, first add a Mode Config Record")
            end
            return false
        end
    end
    if (configRow ["IpsecIKEPolicy.LocalIdentifierType"] == "0") then
        if (configRow ["IpsecIKEPolicy.AddressFamily"] == "2") then
            local ipAddrRow = db.getRowWhere("ipAddressTable","LogicalIfName='WAN"..((configRow ["IpsecIKEPolicy.LocalGateway"]) + 1).."' and addressFamily=2") or ''
            configRow ["IpsecIKEPolicy.LocalIdentifier"] = ipAddrRow ["ipAddressTable.ipAddress"]
        elseif (configRow["IpsecIKEPolicy.AddressFamily"] == "10") then
            local ipAddrRow = db.getRowWhere("ipAddressTable","LogicalIfName='WAN"..((configRow ["IpsecIKEPolicy.LocalGateway"]) + 1).."' and addressFamily=10") or ''
            configRow ["IpsecIKEPolicy.LocalIdentifier"] = ipAddrRow ["ipAddressTable.ipAddress"]
        end
    end
    if (configRow ["IpsecIKEPolicy.LocalIdentifierType"] ~= "0" and
       (configRow ["IpsecIKEPolicy.LocalIdentifier"] == '' or
        configRow ["IpsecIKEPolicy.LocalIdentifier"] == nil)) then
        printCLIError("Invalid Local Identifier")
        return false
    end
    if (configRow ["IpsecIKEPolicy.RemoteIdentifierType"] ~= "0" and
       (configRow ["IpsecIKEPolicy.RemoteIdentifier"] == '' or
        configRow ["IpsecIKEPolicy.RemoteIdentifier"] == nil)) then
        printCLIError("Invalid Remote Identifier")
        return false
    end
    if (configRow ["IpsecIKEPolicy.AuthType"] == "0") then
        if (configRow ["IpsecIKEPolicy.Presharedkey"] == '' or configRow ["IpsecIKEPolicy.Presharedkey"] == nil) then
            printCLIError("Invalid Preshared Key")
            return false
        end
    end
    if (configRow ["IpsecIKEPolicy.DPD"] == "1") then
        if (configRow ["IpsecIKEPolicy.DPDDetectionPeriod"] == '' or configRow ["IpsecIKEPolicy.DPDDetectionPeriod"] == nil) then
            printCLIError("Invalid Detection Period")
            return false
        end
        if (configRow ["IpsecIKEPolicy.DPDFailureCount"] == '' or configRow ["IpsecIKEPolicy.DPDFailureCount"] == nil) then
            printCLIError("Invalid Reconnect after failure count")
            return false
        end
    end
    if (configRow ["IpsecIKEPolicy.XAUTHType"] == "2" and
       (configRow ["IpsecIKEPolicy.XAUTHType1"] == '' or
        configRow ["IpsecIKEPolicy.XAUTHType1"] == nil)) then
        printCLIError("Invalid Xauth type1")
        return false
    end
    if (configRow ["IpsecIKEPolicy.XAUTHType"] == "1") then
        if (configRow ["IpsecIKEPolicy.UserName"] == '' or configRow ["IpsecIKEPolicy.UserName"] == nil) then
            printCLIError("Invalid username")
            return false
        end
        if (configRow ["IpsecIKEPolicy.Password"] == '' or configRow ["IpsecIKEPolicy.Password"] == nil) then
            printCLIError("Invalid Password")
            return false
        end
    end
    return true
end

function ipsecIkePolicyCfgSave(configRow)
    errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	DBTable="IpsecIKEPolicy"	
    if (configRow["IpsecIKEPolicy.XAUTHType"] == "2") then
		configRow["IpsecIKEPolicy.XAUTHType"] = configRow["IpsecIKEPolicy.XAUTHType1"]
	end
    if (configRow["IpsecIKEPolicy._ROWID_"] == nil) then
        errorFlag, statusCode = vipSecure.ikeConfig(configRow, "-1", "add")
	else
	  	errorFlag, statusCode = vipSecure.ikeEditCheck(configRow["IpsecIKEPolicy._ROWID_"])
	    if (errorFlag == "OK") then
	       	errorFlag, statusCode = vipSecure.ikeConfig(configRow, configRow["IpsecIKEPolicy._ROWID_"], "edit")
	    end
	end
	-- save db if no error
	if (errorFlag == "OK") then db.save() end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
    if (errorFlag ~= "OK") then
        print(statusMessage)
    end
end

function ipsecIkePolicyDelete(args)
    errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecIKEPolicy","IKEPolicyName",args[1])
	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		local rows = {}
        rows["rowid"] = configRow["IpsecIKEPolicy._ROWID_"]
		errorFlag, statusCode = vipSecure.ikeDeletePolicy (rows)
        -- save db if no error
        if (errorFlag == "OK") then db.save() end
	    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
        if (errorFlag ~= "OK") then
            print(statusMessage)
        end
	end
end

function ipsecIkePolicyGet()
    local resultTab = {}
    local i=0
    printLabel("List of IKE Policies")
	local table = db.getTable("IpsecIKEPolicy")
    if(#table ~= 0) then
	    for k,v in pairs(table) do
		    i = i + 1
		    local row = table[i]
            
            local mode = ""
            if(row["IpsecIKEPolicy.ExchangeMode"] == "0") then
                mode = "main"
            elseif(row["IpsecIKEPolicy.ExchangeMode"] == "1") then
                mode = "aggressive"
            end

            local encr = ""
            if(row["IpsecIKEPolicy.EncryptionAlgorithm"] == "1") then
                encr = "DES"
            elseif(row["IpsecIKEPolicy.EncryptionAlgorithm"] == "2") then
                encr = "3DES"
            elseif(row["IpsecIKEPolicy.EncryptionAlgorithm"] == "3") then
                encr = "AES-128"
            elseif(row["IpsecIKEPolicy.EncryptionAlgorithm"] == "4") then
                encr = "AES-192"
            elseif(row["IpsecIKEPolicy.EncryptionAlgorithm"] == "5") then
                encr = "AES-256"
            end

            local auth = ""
            if(row["IpsecIKEPolicy.AuthAlgorithm"] == "1") then
                auth = "MD5"
            elseif(row["IpsecIKEPolicy.AuthAlgorithm"] == "2") then
                auth = "SHA-1"
            end

            local dh = ""
            if(row["IpsecIKEPolicy.DHGroup"] == "1") then
                dh = "Group 1 (768 bit)"
            elseif(row["IpsecIKEPolicy.DHGroup"] == "2") then
                dh = "Group 2 (1024 bit)"
            elseif(row["IpsecIKEPolicy.DHGroup"] == "5") then
                dh = "Group 5 (1536 bit)"
            end

            local localId = row["IpsecIKEPolicy.LocalIdentifier"] or ''
            local remoteId = row["IpsecIKEPolicy.RemoteIdentifier"] or ''

            resTab.insertField (resultTab,"Name",row["IpsecIKEPolicy.IKEPolicyName"])
		    resTab.insertField (resultTab,"Mode",mode)
		    resTab.insertField (resultTab,"Local ID",localId)
		    resTab.insertField (resultTab,"Remote ID",remoteId)
		    resTab.insertField (resultTab,"Encryption",encr)
		    resTab.insertField (resultTab,"Authentication",auth)
            resTab.insertField (resultTab,"DH Group",dh)
   	    end
        resTab.print (resultTab, 0)
    end
end

function vpnModeConfigCfgInit(args)
    local configRow = db.getRow("IpsecModeConfigVpnPolicy","ModeConfigRecordName",args[1])
    if (configRow == nil) then
        configRow = {}
        configRow["IpsecModeConfigVpnPolicy.ModeConfigRecordName"] = args[1]
        configRow["IpsecModeConfigVpnPolicy.SALifeTime"] = "3600"
        configRow["IpsecModeConfigVpnPolicy.SALifeTimeType"] = "0"
        configRow["IpsecModeConfigVpnPolicy.EncryptionAlgorithm"] = "2"
        configRow["IpsecModeConfigVpnPolicy.AuthAlgorithm"] = "2"
        configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup"] = "0"
        configRow["IpsecModeConfigVpnPolicy._ROWID_"] = "-1"
    else
        if(configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup"] ~= "0") then
			configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup1"] = configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup"]
			configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup"] = "1"
		else
			configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup1"] = "2"
        end
    end
    return rowId, configRow
end

function vpnModeConfigCfgInputVal(configRow)
    if (configRow["IpsecModeConfigVpnPolicy.FirstPoolStartIP"] == '' or
        configRow["IpsecModeConfigVpnPolicy.FirstPoolStartIP"] == nil or
        configRow["IpsecModeConfigVpnPolicy.FirstPoolStartIP"] == "0.0.0.0") then
        printCLIError ("Invalid first pool start IP")
        return false
    end
    if (configRow["IpsecModeConfigVpnPolicy.FirstPoolEndIP"] == '' or
        configRow["IpsecModeConfigVpnPolicy.FirstPoolEndIP"] == nil or
        configRow["IpsecModeConfigVpnPolicy.FirstPoolEndIP"] == "0.0.0.0") then
        printCLIError ("Invalid first pool end IP")
        return false
    end
    local startIp1 = ''
    local endIp1 = ''
    local startIp2 = ''
    local endIp2 = ''
    local startIp3 = ''
    local endIp3 = ''
    local startIp1 = util.split (configRow ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"],".")
    local endIp1 = util.split (configRow ["IpsecModeConfigVpnPolicy.FirstPoolEndIP"],".")
    for i = 1,3 do
        if (startIp1[i] ~= endIp1[i]) then
            printCLIError("Start and End IP Address must be in same subnet for First pool.")
    	    return false
        end
	end
    if (startIp1[4] >= endIp1[4]) then
        printCLIError ("End IP Address should not be equal to or less than Start IP Address for First Pool")
        return false
    end
    if ((configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= "") and
        (configRow["IpsecModeConfigVpnPolicy.SecondPoolEndIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.SecondPoolEndIP"] ~= "")) then
        startIp2 = util.split (configRow ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"],".")
        endIp2 = util.split (configRow ["IpsecModeConfigVpnPolicy.SecondPoolEndIP"],".")
        for i = 1,3 do
            if (startIp2[i] ~= endIp2[i]) then
                printCLIError("Start and End IP Address must be in same subnet for Second pool.")
    	        return false
            end
	    end
        if (startIp2[4] >= endIp2[4]) then
            printCLIError ("End IP Address should not be equal to or less than Start IP Address for Second Pool")
            return false
        end
    end
    if ((configRow["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= "") and
        (configRow["IpsecModeConfigVpnPolicy.ThirdPoolEndIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.ThirdPoolEndIP"] ~= "")) then
        startIp3 = util.split (configRow ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"],".")
        endIp3 = util.split (configRow ["IpsecModeConfigVpnPolicy.ThirdPoolEndIP"],".")
        for i = 1,3 do
            if (startIp3[i] ~= endIp3[i]) then
                printCLIError("Start and End IP Address must be in same subnet for Third pool.")
    	        return false
            end
	    end
        if (startIp3[4] >= endIp3[4]) then
            printCLIError ("End IP Address should not be equal to or less than Start IP Address for Third Pool")
            return false
        end
    end
    local modeCfgRow = db.getTable("IpsecModeConfigVpnPolicy")
    if (#modeCfgRow ~= 0) then
        local i = 0
        for k,v in pairs(modeCfgRow) do
            i = i + 1
            local row = modeCfgRow[i]
            if (row ~= nil) then
                local status1 = ''
                local status2 = ''
                local status3 = ''
                if (configRow["IpsecModeConfigVpnPolicy._ROWID_"] ~= row["IpsecModeConfigVpnPolicy._ROWID_"]) then
                    status1 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"])
                end
                if (row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= nil and row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= "") then
                    status2 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"])
                end
                if (row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= nil and row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= "") then
                    status3 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"])
                end
                if (status1 == "OK" or status2 == "OK" or status3 == "OK") then
                    if (configRow["IpsecModeConfigVpnPolicy._ROWID_"] ~= row["IpsecModeConfigVpnPolicy._ROWID_"]) then
                        printCLIError("Invalid First Pool Configuration, Subnet already used for different Record's.")
                    else
                        printCLIError("Invalid First Pool Configuration, Subnet repeated for different Pool's")
                    end
                    return false
                end

                local status1 = ''
                local status2 = ''
                local status3 = ''
                if (configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= "") then
                    status1 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"])
                    if(row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= nil and row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= "" and
                       configRow["IpsecModeConfigVpnPolicy._ROWID_"] ~= row["IpsecModeConfigVpnPolicy._ROWID_"] ) then
                        status2 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"])
                    end
                    if(row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= nil and row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= "") then
                        status3 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"])
                    end
                    if (status1 == "OK" or status2 == "OK" or status3 == "OK") then
                        if (configRow["IpsecModeConfigVpnPolicy._ROWID_"] ~= row["IpsecModeConfigVpnPolicy._ROWID_"]) then
                            printCLIError("Invalid Second Pool Configuration, Subnet already used for different Record's.")
                        else
                            printCLIError("Invalid Second Pool Configuration, Subnet repeated for different Pool's")
                        end
                        return false
                    end
                end

                local status1 = ''
                local status2 = ''
                local status3 = ''
                if (configRow["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= "") then
                    status1 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"])
                    if(row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= nil and row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= "") then
                        status2 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"])
                    end
                    if(row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= nil and row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= "" and
                       configRow["IpsecModeConfigVpnPolicy._ROWID_"] ~= row["IpsecModeConfigVpnPolicy._ROWID_"]) then
                        status3 = ifDev.ipSubnet (row ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"])
                    end
                    if (status1 == "OK" or status2 == "OK" or status3 == "OK") then
                        if (configRow["IpsecModeConfigVpnPolicy._ROWID_"] ~= row["IpsecModeConfigVpnPolicy._ROWID_"]) then
                            printCLIError("Invalid Third Pool Configuration, Subnet already used for different Record's.")
                        else
                            printCLIError("Invalid Third Pool Configuration, Subnet repeated for different Pool's")
                        end
                        return false
                    end
                end
            end
        end
    end
    local status1 = ''
    local status2 = ''
    local status3 = ''
    if (configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~= "") then
        status1 = ifDev.ipSubnet (configRow ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"])
        if (status1 == "OK") then
            printCLIError ("Invalid Second Pool Configuration, Subnet repeated for different Pool's")
            return false
        end
    end
    if (configRow["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= nil and configRow["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"] ~= "") then
        status2 = ifDev.ipSubnet (configRow ["IpsecModeConfigVpnPolicy.FirstPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"])
        if(configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~=nil and configRow["IpsecModeConfigVpnPolicy.SecondPoolStartIP"] ~="") then
            status3 = ifDev.ipSubnet (configRow ["IpsecModeConfigVpnPolicy.SecondPoolStartIP"], "255.255.255.0",configRow ["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"])
        end
        if (status2 == "OK" or status3 == "OK") then
            printCLIError ("Invalid Third Pool Configuration, Subnet repeated for different Pool's")
            return false
        end
    end

    if (configRow["IpsecModeConfigVpnPolicy.SALifeTimeType"] == "0") then
        if (tonumber(configRow["IpsecModeConfigVpnPolicy.SALifeTime"]) < 300) then
            printCLIError("Invalid SA Life time value. Please enter a value not less than 300 seconds")
            return false
        end
    elseif (configRow["IpsecModeConfigVpnPolicy.SALifeTimeType"] == "1") then
        if (tonumber(configRow["IpsecModeConfigVpnPolicy.SALifeTime"]) < 1920000) then
            printCLIError("Invalid SA Life time value. Please enter a value not less than 1920000 Kbytes")
            return false
        end
    end
    if(configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup1"] == nil or configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup1"] == "" or configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup1"] == "0" ) then    	
        configRow["IpsecModeConfigVpnPolicy.PFSKeyGroup"] = "0"
    end
    return true
end

function vpnModeConfigCfgSave(configRow)
    errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	DBTable="IpsecModeConfigVpnPolicy"	
    local RowId = configRow["IpsecModeConfigVpnPolicy._ROWID_"]
    if (RowId == "-1") then
	    errorFlag, statusCode = vipSecure.modeConfigConfig(configRow, RowId, "add")
	else
	    errorFlag, statusCode = vipSecure.modeConfigConfig(configRow, RowId, "edit")
	end
	-- save db if no error
	if (errorFlag == "OK") then 
        db.save() 
    else
        statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
        printCLIError (statusMessage)
    end
	statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
end

function vpnModeConfigDelete(args)
    errorFlag="ERROR"
	statusCode=""
	statusMessage=""
	configRow=db.getRow("IpsecModeConfigVpnPolicy","ModeConfigRecordName",args[1])
	if (configRow == nil)then
		printCLIError("Row doesnt exist")
		return "ERROR","Row doesnt exist"
	else
		local rows = {}
        rows["rowid"] = configRow["IpsecModeConfigVpnPolicy._ROWID_"]
		errorFlag, statusCode = vipSecure.modeConfigDelete(rows)
        -- save db if no error
        if (errorFlag == "OK") then 
            db.save() 
        else 
            statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE) or statusCode
            printCLIError (statusMessage)
        end
	    statusMessage = db.getAttribute("stringsMap", "stringId", statusCode, LANGUAGE)
	end
end

function vpnModeConfigGet()
    local resultTab = {}
    local i=0
    printLabel("List of Mode Config Records")
	local table = db.getTable("IpsecModeConfigVpnPolicy")
    if(#table ~= 0) then
	    for k,v in pairs(table) do
		    i = i + 1
		    local row = table[i]
            resTab.insertField (resultTab,"Record Name",row["IpsecModeConfigVpnPolicy.ModeConfigRecordName"])
		    resTab.insertField (resultTab,"Pool Start IP",row["IpsecModeConfigVpnPolicy.FirstPoolStartIP"].."   "..
                                row["IpsecModeConfigVpnPolicy.SecondPoolStartIP"].."   "..row["IpsecModeConfigVpnPolicy.ThirdPoolStartIP"])
            resTab.insertField (resultTab,"Pool End IP",row["IpsecModeConfigVpnPolicy.FirstPoolEndIP"].."   "..
                                row["IpsecModeConfigVpnPolicy.SecondPoolEndIP"].."   "..row["IpsecModeConfigVpnPolicy.ThirdPoolEndIP"])
   	    end
        resTab.print (resultTab, 0)
    end
end
