/* bandwidthProfile.js - API library for Bandwidth Profile configuration */

/* Copyright 2011 - 2013 TeamF1, Inc. */

function bandwidthValidate ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a valid profile name';
    var errMsgL10n2 = 'Invalid Outbound Maximum Bandwidth: Please enter a value between 100 and 100000 Kbps';
    var errMsgL10n3 = 'Invalid Outbound Maximum Bandwidth.';
    var errMsgL10n4 = 'Invalid Outbound Minimum Bandwidth: Please enter a value between 0 and';
    var errMsgL10n5 = 'Invalid Outbound Minimum Bandwidth.';
    var errMsgL10n6 = 'Invalid Inbound Maximum Bandwidth: Please enter a value between 100 and 100000 Kbps';
    var errMsgL10n7 = 'Invalid Inbound Maximum Bandwidth.';
    var errMsgL10n8 = 'Invalid Inbound Minimum Bandwidth: Please enter a value between 0 and';
    var errMsgL10n9 = 'Invalid Inbound Minimum Bandwidth.';
    var errMsgL10n10 = 'Kbps';
    var errMsgL10n11 = 'Please enter a valid maximum number of instances.';

    /* L10N Error Message Collection End */
        
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtProfileName,"+errMsgL10n1;

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    if (isProblemCharArrayCheck(txtFieldIdArr) == false)
        return false;     

	var usrLimitObjMax = document.getElementById ('txtMaxBandwidth0');
	if (numericValueRangeCheck (usrLimitObjMax, 1, errMsgL10n2, 100, 100000, true, errMsgL10n3, errMsgL10n10) == false)
		return false;

	var usrLimitObjMin = document.getElementById ('txtMinBandwidth0');
	if (numericValueRangeCheck (usrLimitObjMin, 1, errMsgL10n4 + " " + usrLimitObjMax.value + errMsgL10n10,
		0, parseInt (usrLimitObjMax.value, 10), true, errMsgL10n5, errMsgL10n10) == false)
		return false;
		
	usrLimitObjMax = document.getElementById ('txtMaxBandwidth1');
	if (numericValueRangeCheck (usrLimitObjMax, 1, errMsgL10n6, 100, 100000, true, errMsgL10n7, errMsgL10n10) == false)
		return false;

	usrLimitObjMin = document.getElementById ('txtMinBandwidth1');
	if (numericValueRangeCheck (usrLimitObjMin, 1, errMsgL10n8 + " " + usrLimitObjMax.value + errMsgL10n10,
		0, parseInt (usrLimitObjMax.value, 10), true, errMsgL10n9, errMsgL10n10) == false)
		return false;

	var maxInstObj = document.getElementById ('txtMaxInst');
	if (!maxInstObj.disabled && (maxInstObj.value == "" || isNaN (maxInstObj.value)))
		{
		alert (errMsgL10n11);
		maxInstObj.focus ();
		return false;
		}
		
	return true;
	}

function checkType ()
	{
	var selectedValue = comboSelectedValueGet ('selType');
	if (selectedValue == "0")
		fieldStateChangeWr ('','','txtMaxInst','');
	else
		fieldStateChangeWr ('txtMaxInst','','','');
	}
	
function bwDirectionCheck()
	{
	var selObj = document.getElementById ('selDirection');
	if (!selObj) return;
	var direction = parseInt (selObj.value, 10);
	if (direction == 1)
		fieldStateChangeWr ('txtMinBandwidth1 txtMaxBandwidth1', '', 'txtMinBandwidth0 txtMaxBandwidth0', '');
	else if (direction == 0)
		fieldStateChangeWr ('txtMinBandwidth0 txtMaxBandwidth0', '', 'txtMinBandwidth1 txtMaxBandwidth1', '');
	else
		fieldStateChangeWr ('', '', 'txtMinBandwidth0 txtMaxBandwidth0 txtMinBandwidth1 txtMaxBandwidth1', '');
	}
	
function bwPrifleInit()
	{
	bwDirectionCheck();
	checkType ();
	}
	
function showMessage ()
    {
    var selValue = radioCheckedValueGet ('BandWidthProfileStatus.Status');
    if (!selValue) return true;
    if (parseInt(selValue, 10) == 1)
		alert ('The WAN connection type must be set properly' +
		" "+'in Network Configuration -> WAN Advanced Option -> Upload/Download' +
		" "+'Settings for Bandwidth Profiling to work properly')
	}

function bandwidthProfileCheck ()
	{
	var selValue = radioCheckedValueGet ('BandWidthProfileStatus.Status');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			fieldStateChangeWr ('','tblListBandwidth','','');
			break;
		case 1:	/* YES */
			fieldStateChangeWr ('', '', '', 'tblListBandwidth');
			break;
		}
	}	
