/* dmz_wan_ipv6.js - API library for DMZ WAN IPv6 configuration */

/* Copyright 2011 - 2013 TeamF1, Inc. */

function fwAddDwInServicesValidate ()
    {    
		
	if (ipv6Validate ('addDWInLanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addDWInLanUserFinish', false, true, '') == false)
	    return false;
	    	    
	if (startEndCompare('addDWInLanUserStart','addDWInLanUserFinish') == false)
	    	return false;
    	
	if (ipv6Validate ('addDWInWanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addDWInWanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addDWInWanUserStart','addDWInWanUserFinish') == false)
		return false;
    	
	return true;	
    }
    
function fwActionCheckDW ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHEDULE":
        case "DROP_BY_SCHEDULE":
			fieldStateChangeWr ('','','selSchedule','');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','','');
			break;
		default:
			fieldStateChangeWr ('selSchedule','','','');
			break;
		}
	}
	    

function dropFieldSelectLanDW (parent)
    {
    if (!parent)
        return;
   	var optVal = document.getElementById (parent.id).value;
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addDWInLanUserFinish', '', 'addDWInLanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addDWInLanUserStart addDWInLanUserFinish', '');
   			break;
   		default:   		
   			fieldStateChangeWr ('addDWInLanUserStart addDWInLanUserFinish', '', '', '');
   			break;
   		}
	}
	
function dropFieldSelectWanDW (parent)
    {
    if (!parent)
        return;
   	var optVal = document.getElementById (parent.id).value;
   	
   	switch (optVal)
   		{
   		case '1':   		
   			fieldStateChangeWr ('addDWInWanUserFinish', '', 'addDWInWanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addDWInWanUserStart addDWInWanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addDWInWanUserStart addDWInWanUserFinish', '', '', '');   			
   			break;
   		}
    }

function dropFieldSelectPublicDstAddr ()
    {
    
	var selObj = document.getElementById('selPublicDstIpAddr');
	if (selObj.disable) return;
   	var optVal = selObj.options[selObj.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case 'OTHER':
   			fieldStateChangeWr ('', '', '', 'tblAddDwInPublicDstIpAddr');
   			break;
   		default:
   			fieldStateChangeWr ('', 'tblAddDwInPublicDstIpAddr', '', '');
   			break;
   		}
	}

function InitialSettingsDW ()
	{
	fwActionCheckDW ();	
	var fldObj = document.getElementById('addDWInLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLanDW (fldObj);
	var fldObj = document.getElementById('addDWInWanUser');
	if (!(fldObj.disable))
		dropFieldSelectWanDW (fldObj);	
	}

function serviceDWCheck ()
	{
	var selServiceValue = comboSelectedValueGet  ('selDWservice');
	if (!selServiceValue) return;
	switch (selServiceValue)
		{
		case "ANY":
            fieldStateChangeWr ('chkTranslatePortNum txtTranslatePortNum','','','');
			break;
			
		default:
            fieldStateChangeWr ('','','chkTranslatePortNum txtTranslatePortNum','');
            translatePortNumCheck ();
			break;
		}
	}

/* add_dw_in_service_IPv6.htm End */

/* add_dw_out_service_IPv6.htm Start */

function fwAddDwOutServicesValidate ()
    {  
    
    if (ipv6Validate ('addDWOutLanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addDWOutLanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addDWOutLanUserStart','addDWOutLanUserFinish') == false)
		return false;
    
    if (ipv6Validate ('addDWOutWanUserStart', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('addDWOutWanUserFinish', false, true, '') == false)
	    return false;
	    
	if (startEndCompare('addDWOutWanUserStart','addDWOutWanUserFinish') == false)
		return false;
	
    return true;
    }
    
function fwActionCheck ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHEDULE":
        case "DROP_BY_SCHEDULE":
			fieldStateChangeWr ('','','selSchedule selQos','');
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','selQos','');
			break;
		default:
			fieldStateChangeWr ('selSchedule selQos','','','');
			break;
		}
   }
	
function dropFieldSelectLan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addDWOutLanUserFinish', '', 'addDWOutLanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addDWOutLanUserStart addDWOutLanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addDWOutLanUserStart addDWOutLanUserFinish', '', '', '');
   			break;
   		}
	}
function dropFieldSelectWan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('addDWOutWanUserFinish', '', 'addDWOutWanUserStart', '');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', 'addDWOutWanUserStart addDWOutWanUserFinish', '');
   			break;
   		default:
   			fieldStateChangeWr ('addDWOutWanUserStart addDWOutWanUserFinish', '', '', '');
   			break;
   		}
    }

function dropFieldSelectNAT (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', '', 'selSnat', 'tblNATIPStart');
   			break;
   		default:
   			fieldStateChangeWr ('selSnat', 'tblNATIPStart', '', '');
   			break;
   		}
    }

function InitialSettings ()
	{
	fwActionCheck ();
	var fldObj = document.getElementById('addDWOutLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLan (fldObj);
	var fldObj = document.getElementById('addDWOutWanUser');
	if (!(fldObj.disable))
		dropFieldSelectWan (fldObj);
	}

function wanModeCheck ()
{
	var wanModeObj = document.getElementById('keyNatIpDisable');
	if(wanModeObj.value == "0")
            fieldStateChangeWr ('selNATIP','', '', '');
	var primWanObj = document.getElementById('hdPrimWan');            
	if (primWanObj.value == "0")
	{
		primWanObj.value = 1;
		optionValueSelect ('selSnat', 'hdPrimWan');            		
		primWanObj.value = 0;
	}
	else if (primWanObj.value == "1")
	{
		primWanObj.value = 2;
		optionValueSelect ('selSnat', 'hdPrimWan');            		
		primWanObj.value = 1;
	}
}

